<template lang="pug">
.modal.is-active( v-if='active' )
	.modal-background( @click='close' )
	.modal-content
		b-card( title="Выбор пользователей" )
			.block
				b-field( label="Фильтр по имени/юзернейму" on-border )
					b-input( v-model='keyword' )
			.block
				b-table( :columns='columns' :data='clients' :loading='pending' :activeAll='selectedAll' @select-all='selectAll' )
					template( #checkbox='{ item }' )
						b-checkbox( :modelValue='isSelected(item.id)' @input='handleInput( item.id, $event )' )
				b-pagination( v-model='page' :total='lastPage' )
			template( #footer )
				a.has-text-danger( @click='clear' ) Отменить выбор
				a.has-text-success( @click='close' ) Подтвердить выбор
	.modal-close.is-large( @click='close' )
</template>

<script setup>
import BTable from "@/components/table/Table.vue"
import BPagination from "@/components/table/Pagination.vue"
import BCheckbox from "@/components/form/Checkbox.vue"
import BField from "@/components/form/Field.vue"
import BInput from "@/components/form/Input.vue"

import { ref, computed, watch, onMounted } from "vue"
import { useClientSrore } from "@/stores/client"

const props = defineProps({
	modelValue: {
		type: Array,
		default: () => []
	},
	active: Boolean
})
const emit = defineEmits([ "update:modelValue", "close" ])

const columns = [
	{
		field: "checkbox"
	},
	{
		label: "Имя",
		field: "fullName"
	},
	{
		label: "Username",
		field: "username"
	}
]

const cs = useClientSrore()

const pending = ref(false)

const clients = computed(() => cs.clients)
const page = computed({
	get: () => cs.page,
	set: val => cs.page = val
})
const keyword = computed({
	get: () => cs.filter,
	set: val => cs.filter = val
})
const lastPage = computed(() => cs.last_page)

const selected = computed(() => props.modelValue)

const selectedAll = computed(() => {
	return clients.value.filter(client => selected.value.indexOf(client.id) > -1).length == clients.value.length
})

const isSelected = computed(() => id => {
	return !!selected.value.find(uid => {
		return uid == id
	})
})

const close = () => emit("close")
const handleInput = ( id, checked ) => {
	const data = selected.value

	if (checked)
		data.push(id)
	else
		data.splice( data.indexOf(id), 1 )

	emit("update:modelValue", data)
}
const selectAll = active => {
	let data = selected.value

	if (active) {
		data = data.concat(
			clients.value.map(({ id }) => id)
		)
		
		data = data.filter((v, i, s) => s.indexOf(v) === i)
	} else {
		data = data.filter(id => !clients.value.find(client => client.id === id))
	}

	emit("update:modelValue", data)
}

const clear = () => emit("update:modelValue", [])

const fetch = async () => {
	cs.filter_type = [ "username", "fullName" ]
	cs.limit = 15

	pending.value = true
	cs.getClients()
	pending.value = false
}

watch(page, fetch)
watch(keyword, () => {
	page.value = 1
	fetch()
})
watch(() => props.active, () => page.value = 1)

onMounted(fetch)
</script>

<style lang="scss" scoped>
.modal-content {
	width: 90%;
	max-width: 1200px;
	:deep(.table) {
		td:first-of-type,
		th:first-of-type {
			width: 3rem;
		}
	}
}
</style>